; yet another screen speedup TSR (hooks int 0x10.2 and .9)

        org  0x100	; original version 93/94, new NASM version 2002

start:  jmp install	; go TSR

;-------

; five:		; could add a bypass flag when detecting page > 0 here
;	jmp short chain

;-------

			; video mode change to mode AL
zero:	cmp word [cs:screenseg],1	; DISABLED currently?
	jz turnoncheck
	cmp bx,0xdead	; magic to turn OFF turbo3
	jz turnoffcheck
othermode:
	cmp al,4	; check out which mode gets activated...
	jb isb800	; mode 0..3: classical text modes
	cmp al,6
	jbe isnone	; mode 4..6: CGA graphics
	cmp al,7
	jbe isb000	; mode 8..0x7f: cannot be sure about those
isnone:	mov word [cs:screenseg],0	; graphics mode
	jmp short chain
isb800:	mov word [cs:screenseg],0xb800	; color mode
        jmp short chain
isb000:	mov word [cs:screenseg],0xb000	; mono mode
	jmp short chain
turnoncheck:
	cmp al,3	; 80x25 mode with bx:cx="Coolfool" re-enables
	jnz chain
	cmp bx,0xc001
	jnz chain
	cmp cx,0xf001
	jnz chain
	jmp short isb800
turnoffcheck:
	cmp al,3	; 80x25 mode with bx:cx="Deadbeef" disables
	jnz othermode
	cmp cx,0xbeaf
	jnz othermode
	mov word [cs:screenseg],1	; DISABLE turbo3
	jmp short chain

;--------------------------------------

; **** MAIN ENTRY POINT OF HANDLER IS HERE, better for jump short ****

turbo:  cmp word [cs:screenseg],0xb000
	jb tst		; only check for mode change in graphics mode

handle: or bh,bh
        jnz noneu	; only hook page 0
        cmp ah,2
        jz two		; move cursor --v
        cmp ah,9
        jz nine		; print char --v

noneu:
;	cmp ah,5
;       jz five		; select active page AL --^

tst:	or ah,ah
        jz zero		; change video mode --^
chain:			; chain to old int 0x10
        db 0eah		; jump word ofx:sek
ofs     dw 0ff53h
sek     dw 0f000h

;--------------------------------------

	; print char AL color BL on page BH, CX times, no chars special.
nine:	cmp cx,1		; number of times to write...
	jNZ chain		; only hook "print 1 char" case!
        push ax
        push di
        push Es
        mov Es,[cs:screenseg]	; es = 40h
        cld
        mov ah,bl
tt2:    mov di,[cs:posi]	; current position
        stosw			; print char AL color BL
        mov [cs:posi],di	; update position (needs no linewrap)
        pop Es
        pop di
        pop ax
        iret

;-------

two:    push ds			; set position to DL DH on page BH
        mov ds,[cs:bioseg]	; es = 40h
        mov [ds:50h],dx		; save position (dl=col dh=row)
        push ax			; would be at ds:52h for page 1 and so on
        push cx
          push dx

;       mov cl,dh
;	xor ch,ch		; or use movzx cx,dh ...
;         imul cx,cx,80		; 386 specific, and better to use
				; [40:4a] columns on screen anyway...
	mov al,[ds:4ah]		; ***  columns on screen (ignore high byte)
	mul dh			; *** * current row
	mov cx,ax		; *** store result

        xor dh,dh
        add cx,dx               ; obvious: add current column

          mov dx,3d4h		; program hardware cursor position
          mov al,14
          mov ah,ch
          out dx,ax		; careful, PORT ACCESS
          inc al
          mov ah,cl
          out dx,ax		; careful, PORT ACCESS 

        add cx,cx		; x2 to get address in screen buffer
        mov [cs:posi],cx	; store position for write char

         pop dx
        POP CX
        pop ax
        pop ds
        iret

; **************************************************************

posi:		dw 0		; current cursor position as offset
screenseg:	dw 0b800h	; current screen buffer segmen
bioseg:		dw 00040h	; constant: BIOS data segment

; **************************************************************

hello:	db 'TURBO3 Screenspeeder installed!',13,10,13,10
hello2:	db 'TURBO3 public domain simplistic screen speedup tool',13,10
	db 'by Eric Auer eric@coli.uni-sb.de 1993-2002.',13,10
	db 'Start with no arguments to install as TSR.',13,10
	db 'Use TURBO3 0 to disable and TURBO3 1 to reenable.'
	db 13,10,'$'
onmsg:	db 'Sent magic TURBO3 turn on command.',13,10,'$'
offmsg:	db 'Sent magic TURBO3 turn off command.',13,10,'$'

install:
	cld
	mov si,0x80
	xor cx,cx
	lodsb
	mov cl,al	; command line length
parse:	lodsb
	cmp al,'1'
	jz enabler
	cmp al,'0'
	jz disabler
	cmp al,'?'
	jz helper
	cmp al,13
	jz parsed	; double security if CX is wrong
	loop parse
parsed:
	mov es,[cs:2ch]
        mov ah,49h
        int 21h 	; RELEASE ENVIRONMENT

	; could switch to mode 3 page 0 here

        mov ax,3510h	; read old int 0x10
        int 21h
        mov [cs:sek],es
        mov [cs:ofs],bx
        mov ax,2510h	; hook int 0x10
        mov dx,turbo	; our new handler!
        int 21h

	mov dx,hello	; prepare to print string
	mov ah,9	; string$ print
	int 21h
        mov ax,3100h	; go TSR
        mov dx,hello+15	; message, but also pointer to
        mov cl,4	; "end of resident part"
        shr dx,cl	; translate into paragraphs
        int 21h

helper:
	mov dx,hello2	; help message
xleave:	mov ah,9
	int 21h		; print string$
	mov ax,4c00h
	int 21h		; exit
enabler:
	mov bx,0xc001
	mov cx,0xf001
	mov ax,3
	int 0x10	; magic turn ON command
	mov dx,onmsg
	jmp short xleave
disabler:
	mov bx,0xdead
	mov cx,0xbeef
	mov ax,3
	int 0x10	; magic turn OFF command
	mov dx,offmsg
	jmp short xleave

